//----------------------------------------------------------------------//
// ėpʊ֐															//
//																		//
//----------------------------------------------------------------------//
#include <wininet.h>
#include <setupapi.h>
#include <cfgmgr32.h>
#include "usr_scale.h"
#include "usr_shell.h"
#include "usr_color.h"
#include "UserFunc.h"

#pragma link "win64\\release\\psdk\\wininet.a"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//u|C^[IɋK̃{^ɈړvL?
//---------------------------------------------------------------------------
bool is_SnapToDefBtn()
{
	BOOL sw;
	return (::SystemParametersInfo(SPI_GETSNAPTODEFBUTTON, 0, &sw, 0) && sw);
}

//---------------------------------------------------------------------------
//}EXJ[\ʒũEBhE擾
//---------------------------------------------------------------------------
HWND get_window_from_pos()
{
	POINT p;
	::GetCursorPos(&p);
	return ::WindowFromPoint(p);
}

//---------------------------------------------------------------------------
//Vistaȍ~̊gt[ɑΉEBhE`̎擾
//---------------------------------------------------------------------------
TRect get_window_rect(HWND hWnd)
{
	TRect rc = Rect(0, 0, 0, 0);
	if (::DwmGetWindowAttribute(hWnd, DWMWA_EXTENDED_FRAME_BOUNDS, &rc, sizeof(rc))!=S_OK) ::GetWindowRect(hWnd, &rc);
	if ((rc.Top > rc.Bottom) || (rc.Left > rc.Right)) rc = Rect(0, 0, 0, 0);
	return rc;
}
//---------------------------------------------------------------------------
//Vistaȍ~̊gt[ɑΉTCYݒ
//---------------------------------------------------------------------------
void set_window_pos_ex(HWND hWnd, TRect rc)
{
	TRect rc1, rc2;
	::GetWindowRect(hWnd, &rc1);
	if (::DwmGetWindowAttribute(hWnd, DWMWA_EXTENDED_FRAME_BOUNDS, &rc2, sizeof(rc2))!=S_OK) rc2 = rc1;
	rc.Left   += (rc1.Left   - rc2.Left);
	rc.Right  += (rc1.Right  - rc2.Right);
	rc.Top	  += (rc1.Top    - rc2.Top);
	rc.Bottom += (rc1.Bottom - rc2.Bottom);

	if (::IsIconic(hWnd)) ::ShowWindow(hWnd, SW_RESTORE);
	::SetWindowPos(hWnd, HWND_TOP, rc.Left, rc.Top, rc.Width(), rc.Height(), SWP_SHOWWINDOW);
}

//---------------------------------------------------------------------------
//tH[\j^͂ݏoĂ܂悤ɒ
//---------------------------------------------------------------------------
void adjust_form_pos(TForm *frm)
{
	TRect frm_rc = frm->BoundsRect;
	TRect mon_rc = frm->Monitor->BoundsRect;
	int dx = 0, dy = 0;
	if (frm_rc.Right > mon_rc.Right)	dx = mon_rc.Right - frm_rc.Right;
	if (frm_rc.Bottom > mon_rc.Bottom)	dy = mon_rc.Bottom - frm_rc.Bottom;
	if (frm_rc.Left < mon_rc.Left)		dx = mon_rc.Left - frm_rc.Left;
	if (frm_rc.Top < mon_rc.Top)		dy = mon_rc.Top - frm_rc.Top;
	if (dx!=0 || dy!=0) {
		OffsetRect(frm_rc, dx, dy);
		frm->BoundsRect = frm_rc;
	}
}

//---------------------------------------------------------------------------
//_CAOĂяotH[̒ɕ\
//	j^͂ݏo܂悤ɒ
//	Ώۂ Position = poDesigned
//---------------------------------------------------------------------------
int show_ModalDlg(TForm *dlg)
{
	TForm *frm = (Screen->ActiveForm && Screen->ActiveForm!=Application->MainForm)?
						Screen->ActiveForm : Application->MainForm;
	dlg->Left = frm->Left;
	dlg->Top  = frm->Top;
	dlg->BoundsRect = frm->BoundsRect.CenteredRect(dlg->BoundsRect);
	adjust_form_pos(dlg);
	return dlg->ShowModal();
}

//---------------------------------------------------------------------------
//Rg[ɉENbNj[\
//---------------------------------------------------------------------------
void show_PopupMenu(TPopupMenu *mp, TControl *cp)
{
	if (mp && cp) {
		TPoint p = cp->ClientToScreen(Point(16, 16));
		ClearKeyBuff(true);
		mp->Popup(p.x, p.y);
	}
}
//---------------------------------------------------------------------------
void show_PopupMenu(TListBox *lp)
{
	show_PopupMenu(lp->PopupMenu, lp);
}
//---------------------------------------------------------------------------
void show_PopupMenu(TCheckListBox *lp)
{
	show_PopupMenu(lp->PopupMenu, lp);
}
//---------------------------------------------------------------------------
void show_PopupMenu(TStringGrid *gp)
{
	show_PopupMenu(gp->PopupMenu, gp);
}

//---------------------------------------------------------------------------
//ListBox ɃeLXgݒ
//---------------------------------------------------------------------------
void set_ListBoxText(TListBox *lp, const _TCHAR *s)
{
	lp->Items->Text = s;
}
//---------------------------------------------------------------------------
//ComboBox ɃeLXgݒ
//---------------------------------------------------------------------------
void set_ComboBoxText(TComboBox *cp, const _TCHAR *s)
{
	cp->Items->Text = s;
}

//---------------------------------------------------------------------------
//ComboBox ɗǉ
//---------------------------------------------------------------------------
void add_ComboBox_history(TComboBox *cp, UnicodeString kwd)
{
	if (!cp) return;

	if (kwd.IsEmpty()) kwd = cp->Text;
	if (!kwd.IsEmpty()) {
		TStrings *lp = cp->Items;
		int idx = lp->IndexOf(kwd);
		if (idx!=-1) lp->Delete(idx);
		lp->Insert(0, kwd);

		if (cp->Style==csDropDownList)
			cp->ItemIndex = 0;
		else
			cp->Text = kwd;
	}
}
//---------------------------------------------------------------------------
//ComboBox 痚폜
//---------------------------------------------------------------------------
int del_ComboBox_history(TComboBox *cp, UnicodeString kwd)
{
	int idx = -1;
	if (cp) {
		if (kwd.IsEmpty()) kwd = cp->Text;
		if (!kwd.IsEmpty()) {
			TStrings *lp = cp->Items;
			idx = lp->IndexOf(kwd);
			if (idx!=-1) lp->Delete(idx);
			cp->Text = EmptyStr;
		}
	}
	return idx;
}

//---------------------------------------------------------------------------
//Nbv{[hEeLXg擾
//---------------------------------------------------------------------------
UnicodeString GetClipboardText(
	bool top_sw)	//sڂ̂ݎ擾	(default = false)
{
	UnicodeString ret_str;
	if (Clipboard()->HasFormat(CF_TEXT)) {
		if (top_sw) {
			std::unique_ptr<TStringList> sbuf(new TStringList());
			sbuf->Text = Clipboard()->AsText;
			if (sbuf->Count>0) ret_str = sbuf->Strings[0];
		}
		else {
			ret_str = Clipboard()->AsText;
		}
	}
	return ret_str;
}

//---------------------------------------------------------------------------
//IMEJĂ邩?
//---------------------------------------------------------------------------
bool is_IME_Open(HWND hWnd)
{
	bool ret  = false;
	HIMC hIMC = ::ImmGetContext(hWnd);
	if (hIMC) {
		ret = ::ImmGetOpenStatus(hIMC);
		::ImmReleaseContext(hWnd, hIMC);
	}
	return ret;
}
//---------------------------------------------------------------------------
//IME͒?
//---------------------------------------------------------------------------
bool is_IME_Typing(HWND hWnd)
{
	bool ret = false;
	HIMC hIMC = ::ImmGetContext(hWnd);
	if (hIMC) {
		ret = ::ImmGetOpenStatus(hIMC) && ::ImmGetCompositionString(hIMC, GCS_COMPSTR, NULL, 0)>0;
		::ImmReleaseContext(hWnd, hIMC);
	}
	return ret;
}
//---------------------------------------------------------------------------
//IME͂Ȃ
//---------------------------------------------------------------------------
bool is_IME_Empty(HWND hWnd)
{
	bool ret = false;
	HIMC hIMC = ::ImmGetContext(hWnd);
	if (hIMC) {
		ret = ::ImmGetOpenStatus(hIMC) && ::ImmGetCompositionString(hIMC, GCS_COMPSTR, NULL, 0)==0;
		::ImmReleaseContext(hWnd, hIMC);
	}
	return ret;
}
//---------------------------------------------------------------------------
//IME
//---------------------------------------------------------------------------
void CloseIME(HWND hWnd)
{
	HIMC hIMC = ::ImmGetContext(hWnd);
	if (hIMC) {
		if (::ImmGetOpenStatus(hIMC)) ::ImmSetOpenStatus(hIMC, FALSE);
		::ImmReleaseContext(hWnd, hIMC);
	}
}

//---------------------------------------------------------------------------
//Xg{bNX̍ڈʒuɃ}EXJ[\ړ
//---------------------------------------------------------------------------
TPoint get_ListItemPos(TListBox *lp, int xp)
{
	if (xp==0) xp = lp->ClientWidth/3;
	return lp->ClientToScreen(Point(xp, (lp->ItemIndex - lp->TopIndex) * lp->ItemHeight + lp->ItemHeight/2));
}

//---------------------------------------------------------------------------
void pos_ListBoxItem(TListBox *lp, int xp)
{
	if (xp==0) xp = lp->ClientWidth/3;
	Mouse->CursorPos = get_ListItemPos(lp, xp);
}

//---------------------------------------------------------------------------
//wLoX̃tHgfBOĂ邩H
//---------------------------------------------------------------------------
bool has_Leading(TCanvas *cv)
{
	return (cv->TextHeight("Q")>abs(cv->Font->Height));
}

//---------------------------------------------------------------------------
//wtHgɂ`敝擾
//---------------------------------------------------------------------------
int get_CharWidth_Font(
	TFont *font,
	int n)			//pPʂ̕
{
	std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
	TCanvas *cv = bmp->Canvas;
	cv->Font->Assign(font);
	return get_CharWidth(cv, n);
}

//---------------------------------------------------------------------------
//͗̕𐔒l
//---------------------------------------------------------------------------
int EditToInt(TLabeledEdit *ep,
	int def)	//ftHgl (default = 0);
{
	return ep->Text.ToIntDef(def);
}
//---------------------------------------------------------------------------
int EditToInt(TEdit *ep, int def)
{
	return ep->Text.ToIntDef(def);
}

//---------------------------------------------------------------------------
//N TDate 擾 (␳)
//IsȔN/w肷ƗO𑗏o
//---------------------------------------------------------------------------
TDate set_NormDay(unsigned short y, unsigned short m, unsigned short d)
{
	unsigned short d_max = DaysInMonth(TDate(y, m, 1));
	return TDate(y, m, (d>d_max)? d_max : d);
}

//---------------------------------------------------------------------------
// TDateTime ɕϊ
//---------------------------------------------------------------------------
bool ToDateTime(UnicodeString s, TDateTime *dt)
{
	try {
		*dt = str_to_DateTime(to_HalfWidth(Trim(s)));
		return true;
	}
	catch (...) {
		return false;
	}
}

//---------------------------------------------------------------------------
//擾
//---------------------------------------------------------------------------
UnicodeString format_DateTime(
	TDateTime dt,	//
	bool omit)		//Ȃtȗ (default = false)
{
	if (dt==(TDateTime)0) {
		return UnicodeString("???\?/?\?/?? ??:??:??");
	}
	else {
		if (omit && IsToday(dt))
			return FormatDateTime("hh:nn:ss", dt);
		else
			return FormatDateTime("yyyy'/'mm'/'dd hh:nn:ss", dt);
	}
}
//---------------------------------------------------------------------------
//t擾
//---------------------------------------------------------------------------
UnicodeString format_Date(TDateTime dt)
{
	return FormatDateTime("yyyy'/'mm'/'dd", dt);
}

//---------------------------------------------------------------------------
//擾 (FormatDateTime ̊g)
// $EN ꍇP[ en-US ɂ
//---------------------------------------------------------------------------
UnicodeString format_DateTimeEx(UnicodeString fmt, TDateTime dt)
{
	TFormatSettings fs = remove_text(fmt, "$EN")? TFormatSettings::Create("en-US") : TFormatSettings::Create();
	fmt = ReplaceStr(ReplaceStr(fmt, "\'/\'", "/"), "/", "\'/\'");
	return FormatDateTime(fmt, dt, fs);
}

//---------------------------------------------------------------------------
//t擾
//@Ύw: {<|=|>}-n{D|M|Y}@@(D:AM:AY:N)
//@Ύw: {<|=|>}yyyy/mm/dd
//
//  ߂l : 1: < Â/ 2: = / 3: > V/ 0: Ȃ
//			-1: G[
//---------------------------------------------------------------------------
int get_DateCond(UnicodeString prm, TDateTime &dt)
{
	try {
		int cnd = 0;

		if (!prm.IsEmpty()) {
			cnd = UnicodeString("<=>").Pos(prm[1]);
			if (cnd>0) {
				prm.Delete(1, 1);
				//Ύw
				if (prm.Length()==10 && prm[5]=='/' && prm[8]=='/') {
					dt = str_to_DateTime(prm);
				}
				//Ύw
				else {
					UnicodeString ut_str = prm.SubString(prm.Length(), 1).UpperCase();
					if (!ContainsText("DMY", ut_str)) Abort();
					delete_end(prm);
					dt = Date();
					int dn = prm.ToIntDef(0);
					if (dn!=0) {
						switch (idx_of_word_i("D|M|Y", ut_str)) {
						case 0: dt = IncDay(  dt, dn); break;
						case 1: dt = IncMonth(dt, dn); break;
						case 2: dt = IncYear( dt, dn); break;
						}
					}
				}
			}
			else cnd = -1;
		}

		return cnd;
	}
	catch (...) {
		return -1;
	}
}

//---------------------------------------------------------------------------
//ʃXg̐`
//  "t@C\te" --> "t@C   e"
//  e TAB ܂܂Ă폜
//  ߂l: t@C̍ő啝
//---------------------------------------------------------------------------
int format_res_list(TStringList *lst, int mgn, int min_wd)
{
	//t@C̍ő啝擾
	int max_len = 0;
	for (int i=0; i<lst->Count; i++) max_len_half(max_len, get_pre_tab(lst->Strings[i]));
	max_len += mgn;
	if (max_len<min_wd) max_len = min_wd;

	//ʂ𐮌`
	for (int i=0; i<lst->Count; i++) {
		UnicodeString lbuf = lst->Strings[i];
		lst->Strings[i] = align_l_str(get_pre_tab(lbuf), max_len, ReplaceStr(get_post_tab(lbuf), "\t", EmptyStr));
	}

	return max_len;
}

//---------------------------------------------------------------------------
//t@C̃vpeB\
//---------------------------------------------------------------------------
void ShowPropertyDialog(UnicodeString fnam)
{
	if (fnam.IsEmpty()) return;

	SHELLEXECUTEINFO sei = {sizeof(SHELLEXECUTEINFO)};
	sei.lpFile = ExcludeTrailingPathDelimiter(fnam).c_str();
	sei.lpVerb = _T("properties");
	sei.fMask  = SEE_MASK_INVOKEIDLIST | SEE_MASK_NOCLOSEPROCESS | SEE_MASK_FLAG_NO_UI;
	::ShellExecuteEx(&sei);
}

//---------------------------------------------------------------------------
//݈ʒũXgڂ폜
//---------------------------------------------------------------------------
void delete_ListItem(TCustomListBox *lp)
{
	if (lp) {
		int idx = lp->ItemIndex;
		if (idx!=-1) {
			lp->Items->Delete(idx);
			lp->ItemIndex = (idx<lp->Count)? idx : lp->Count - 1;
		}
	}
}

//---------------------------------------------------------------------------
//Xg{bNX̍ڂɌr` (wi̔]F)
//---------------------------------------------------------------------------
void draw_ListItemLine(TCustomListBox *lp, int idx)
{
	TPenMode org_md = lp->Canvas->Pen->Mode;
	int		 org_wd = lp->Canvas->Pen->Width;
	lp->Canvas->Pen->Mode  = pmNot;
	lp->Canvas->Pen->Width = 2;
	if (idx!=-1) {
		TRect r = lp->ItemRect(idx);
		int   y = (lp->ItemIndex<idx)? r.Bottom : r.Top;
		lp->Canvas->MoveTo(0, y);
		lp->Canvas->LineTo(lp->Width, y);
	}
	lp->Canvas->Pen->Mode  = org_md;
	lp->Canvas->Pen->Width = org_wd;
}

//---------------------------------------------------------------------------
//[_tbgȐ` (w=1 ̏ꍇ͂̂܂)
//---------------------------------------------------------------------------
void draw_Line(
	TCanvas *cv,
	int x0, int y0, int x1, int y1,
	int w,				//
	TColor col, 		//F
	TPenStyle style)	// (default = psSolid)
{
	if (w>1) {
		int c = ColorToRGB(col);
		LOGBRUSH l_brush;
		l_brush.lbStyle = BS_SOLID;
		l_brush.lbColor = RGB(GetRValue(c), GetGValue(c), GetBValue(c));
		l_brush.lbHatch = 0;
		DWORD p_style = PS_GEOMETRIC|PS_ENDCAP_FLAT|PS_JOIN_MITER;

		switch (style) {
		case psDot:  p_style |= PS_DOT;  break;
		case psDash: p_style |= PS_DASH; break;
		default:     p_style |= PS_SOLID;
		}

		HPEN hPen = ::ExtCreatePen(p_style, w, &l_brush, 0, 0);
		HPEN hOldPen = (HPEN)::SelectObject(cv->Handle, hPen);
		cv->Pen->Handle = hPen;
		cv->MoveTo(x0, y0);  cv->LineTo(x1, y1);
		::SelectObject(cv->Handle, hOldPen);
		::DeleteObject(hPen);
	}
	else {
		cv->Pen->Mode  = pmCopy;
		cv->Pen->Style = style;
		cv->Pen->Color = col;
		cv->Pen->Width = w;
		cv->MoveTo(x0, y0);  cv->LineTo(x1, y1);
	}

	cv->Pen->Style = psSolid;
}

//---------------------------------------------------------------------------
//wiF(Brush)̋PxlăZp[^`
//---------------------------------------------------------------------------
void draw_Separator(
	TCanvas *cv, TRect rc,
	TColor bg)	//wiF	(default = clNone : cv->Brush->Color)
{
	int yp = rc.Top + rc.Height()/2;
	int x0 = rc.Left  + 4;
	int x1 = rc.Right - 4;

	double v  = GetLuminance((bg==Graphics::clNone)? cv->Brush->Color : bg);
	TColor c0 = TColor((v>0.5)? RGB(0x77, 0x77, 0x77) : RGB(0x33, 0x33, 0x33));	//***
	TColor c1 = TColor((v>0.5)? RGB(0xdd, 0xdd, 0xdd) : RGB(0x99, 0x99, 0x99));	//***

	cv->Pen->Style = psSolid;
	cv->Pen->Width = 1;
	cv->Pen->Color = c0;	cv->MoveTo(x0, yp);  cv->LineTo(x1, yp++);
	cv->Pen->Color = c1;	cv->MoveTo(x0, yp);  cv->LineTo(x1, yp);
}
//---------------------------------------------------------------------------
//wiF(Brush)lĕ`
//---------------------------------------------------------------------------
void draw_separateLine(TCanvas *cv, TRect rc,
	int pos)	//ʒu 0=/ 1=/ 2= (default = 0)
{
	cv->Pen->Color = SelectWorB(cv->Brush->Color, 0.25);	//***
	cv->Pen->Style = psSolid;
	cv->Pen->Width = 1;

	switch (pos) {
	case 1:
		cv->MoveTo(rc.Left  + 2, rc.Top + rc.Height()/2);
		cv->LineTo(rc.Right - 2, rc.Top + rc.Height()/2);
		break;
	case 2:
		cv->MoveTo(rc.Left  + 2, rc.Bottom - 1);
		cv->LineTo(rc.Right - 2, rc.Bottom - 1);
		break;
	default:
		cv->MoveTo(rc.Left,      rc.Top);
		cv->LineTo(rc.Right + 1, rc.Top);
	}
}

//---------------------------------------------------------------------------
//k䗦擾
//---------------------------------------------------------------------------
double get_ZoomRatio(int vw, int vh, int iw, int ih, int mgn, double limit)
{
	if (iw==0 || ih==0) return 1.0;

	if (mgn>0) {
		vw -= mgn*2;
		vh -= mgn*2;
	}

	double r;
	bool v_is_v = (vh>vw);
	bool i_is_v = (ih>iw);
	if ((v_is_v && i_is_v) || (!v_is_v && !i_is_v))
		//c֌W
		r = std::max(std::min(1.0 * vw/ih, 1.0 * vh/iw), std::min(1.0 * vw/iw, 1.0 * vh/ih));
	else
		//c֌WႤ
		r = std::min(std::min(1.0 * vw/ih, 1.0 * vh/iw), std::min(1.0 * vw/iw, 1.0 * vh/ih));

	if (r>limit) r = 1.0;

	return r;
}

//---------------------------------------------------------------------------
//`ɃAt@uh
//---------------------------------------------------------------------------
void alpha_blend_Rect(TCanvas *cv, int x, int y, int w, int h, TColor col, int alpha)
{
	BLENDFUNCTION blend_f;
	blend_f.BlendOp				= AC_SRC_OVER;
	blend_f.BlendFlags			= 0;
	blend_f.SourceConstantAlpha = alpha;
	blend_f.AlphaFormat			= 0;

	std::unique_ptr<Graphics::TBitmap> bp_b(new Graphics::TBitmap());
	bp_b->SetSize(8, 8);
	bp_b->Canvas->Brush->Style = bsSolid;
	bp_b->Canvas->Brush->Color = col;
	bp_b->Canvas->FillRect(TRect(0, 0, 8, 8));
	::AlphaBlend(cv->Handle, x, y, w, h, bp_b->Canvas->Handle, 0, 0, 8, 8, blend_f);
}
//---------------------------------------------------------------------------
void alpha_blend_Rect(TCanvas *cv, TRect rc, TColor col, int alpha)
{
	alpha_blend_Rect(cv, rc.Left, rc.Top, rc.Width(), rc.Height(), col, alpha);
}

//---------------------------------------------------------------------------
//TUpDown ̏
//---------------------------------------------------------------------------
void init_UpDown(TUpDown *udp, int n)
{
	udp->Position = n;
	TCustomEdit *ep = dynamic_cast<TCustomEdit *>(udp->Associate);
	if (ep) ep->Text = udp->Position;
}

//---------------------------------------------------------------------------
//Obh̃Zwb_ɍ킹
//---------------------------------------------------------------------------
void set_GridFromHeader(THeaderControl *hp, TStringGrid *gp)
{
	int cnt = std::min(hp->Sections->Count, gp->ColCount);
	int wd = 0;
	for (int i=0; i<cnt; i++) {
		gp->ColWidths[i] = hp->Sections->Items[i]->Width - gp->GridLineWidth;
		wd += hp->Sections->Items[i]->Width;
	}

	//]̃ZNV͎c蕝ɍ킹
	if (hp->Sections->Count>gp->ColCount)
		hp->Sections->Items[gp->ColCount]->Width = std::max(hp->Width - wd, 0);
}
//---------------------------------------------------------------------------
//wb_̗񕝂Obh̃Zɍ킹
//---------------------------------------------------------------------------
void set_HeaderFromGrid(TStringGrid *gp, THeaderControl *hp)
{
	int cnt = std::min(hp->Sections->Count, gp->ColCount);
	int wd = 0;
	for (int i=0; i<cnt; i++) {
		hp->Sections->Items[i]->Width = gp->ColWidths[i] + gp->GridLineWidth + ((i==0)? 1 : 0);
		wd += hp->Sections->Items[i]->Width;
	}

	//]̃ZNV͎c蕝ɍ킹
	if (hp->Sections->Count>gp->ColCount)
		hp->Sections->Items[gp->ColCount]->Width = std::max(hp->Width - wd, 0);
}

//---------------------------------------------------------------------------
//wb_̗񕝂ݒ(Œ)
//---------------------------------------------------------------------------
void set_HeaderSecWidth(THeaderControl *hp, int cnt, ...)
{
	THeaderSections *sp = hp->Sections;

	//UAŒ
	for (int i=0; i<sp->Count; i++) {
		sp->Items[i]->MinWidth = 0;
		sp->Items[i]->MaxWidth = 10000;
	}

	va_list ap;
	va_start(ap, cnt);
	for (int i=0; i<cnt; i++) {
		int w = va_arg(ap, int);
		if (i<sp->Count) sp->Items[i]->Width = w;
	}
	va_end(ap);

	//񂪖wȂc蕝ɐݒ
	if (cnt == sp->Count-1) {
		int w = hp->ClientWidth;
		for (int i=0; i<sp->Count-1; i++) w -= sp->Items[i]->Width;
		sp->Items[sp->Count - 1]->Width = std::max(w, 0);
	}

	//񕝂Œ
	for (int i=0; i<sp->Count; i++) {
		int w = sp->Items[i]->Width;
		sp->Items[i]->MinWidth = w;
		sp->Items[i]->MaxWidth = w;
	}
}
//---------------------------------------------------------------------------
void adjust_HeaderSecWidth(THeaderControl *hp, int idx)
{
	THeaderSections *sp = hp->Sections;
	int wd = hp->Width;
	for (int i=0; i<sp->Count; i++) if (i!=idx) wd -= sp->Items[i]->Width;
	sp->Items[idx]->Width = wd;
}

//---------------------------------------------------------------------------
//Xe[^Xo[̃plݒ
//---------------------------------------------------------------------------
int set_SttBarPanelWidth(TStatusBar *sp, int idx,
	int n)	//(pP)
{
	TCanvas *cv = sp->Canvas;
	cv->Font->Assign(sp->Font);
	int wd = (n>0)? get_CharWidth(cv, n + 2, 16) : 0;
	sp->Panels->Items[idx]->Width = wd;
	return wd;
}
//---------------------------------------------------------------------------
int set_SttBarPanelWidth(TStatusBar *sp, int idx,
	UnicodeString s)	//
{
	TCanvas *cv = sp->Canvas;
	cv->Font->Assign(sp->Font);
	int wd = cv->TextWidth(s + "__");
	sp->Panels->Items[idx]->Width = wd;
	return wd;
}

//---------------------------------------------------------------------------
//Obh̍sNA
//---------------------------------------------------------------------------
void clear_GridRow(TStringGrid *gp, int row, int col)
{
	if (row>=0 && row<gp->RowCount) {
		for (int i=col; i<gp->ColCount; i++) gp->Cells[i][row] = EmptyStr;
	}
}

//---------------------------------------------------------------------------
//Obȟ݈ʒuCfbNX
//---------------------------------------------------------------------------
int get_GridIndex(TStringGrid *gp, int max_count)
{
	int idx = (gp->ColCount * gp->Row) + gp->Col;
	if (idx>=max_count) idx = -1;
	return idx;
}

//---------------------------------------------------------------------------
//ListBox ̃J[\ړ
//---------------------------------------------------------------------------
void ListBoxCursorDown(TListBox *lp)
{
	int idx = lp->ItemIndex + 1;
	if (idx<lp->Count) ListBoxSetIndex(lp, idx);
}
//---------------------------------------------------------------------------
void ListBoxCursorDown(TListBox *lp, int n)
{
	ListBoxSetIndex(lp, std::min(lp->ItemIndex + n, lp->Count - 1));
}
//---------------------------------------------------------------------------
void ListBoxCursorUp(TListBox *lp)
{
	int idx = lp->ItemIndex - 1;
	if (idx>=0) ListBoxSetIndex(lp, idx);
}
//---------------------------------------------------------------------------
void ListBoxCursorUp(TListBox *lp, int n)
{
	ListBoxSetIndex(lp, std::max(lp->ItemIndex - n, 0));
}
//---------------------------------------------------------------------------
void ListBoxPageDown(TListBox *lp)
{
	ListBoxCursorDown(lp, lp->ClientHeight/lp->ItemHeight - 1);
}
//---------------------------------------------------------------------------
void ListBoxPageUp(TListBox *lp)
{
	ListBoxCursorUp(lp, lp->ClientHeight/lp->ItemHeight - 1);
}
//---------------------------------------------------------------------------
void ListBoxTop(TListBox *lp)
{
	ListBoxSetIndex(lp, 0);
}
//---------------------------------------------------------------------------
void ListBoxEnd(TListBox *lp)
{
	if (lp->Count>0) ListBoxSetIndex(lp, lp->Count - 1);
}

//---------------------------------------------------------------------------
void ListBoxSetIndex(TListBox *lp, int idx,
	bool top_sw)	//}[WtŃgbvɃXN[	(default = false)
{
	if (lp->Count==0) return;

	if (idx<0) {
		lp->ItemIndex = 0;
	}
	else if (top_sw) {
		lp->TopIndex  = std::max(idx - LISTBOX_SCRMGN, 0);
		lp->ItemIndex = idx;
	}
	else if (idx==lp->ItemIndex) {
		//̈OXN[
		int pn = lp->ClientHeight/lp->ItemHeight;
		if (lp->ItemIndex<lp->TopIndex)
			lp->TopIndex = std::max(lp->ItemIndex - LISTBOX_SCRMGN, 0);
		else if (lp->ItemIndex > lp->TopIndex + pn - 1)
			lp->TopIndex = std::max(lp->ItemIndex - pn + 1 + LISTBOX_SCRMGN, 0);
	}
	else {
		if (idx>=lp->Count) idx = lp->Count - 1;
		//
		if (idx<lp->ItemIndex) {
			if (idx < lp->TopIndex+LISTBOX_SCRMGN)
				lp->TopIndex = std::max(idx - LISTBOX_SCRMGN, 0);
		}
		//
		else {
			int pn = lp->ClientHeight/lp->ItemHeight;
			if (idx > (lp->TopIndex + pn - 1 - LISTBOX_SCRMGN))
				lp->TopIndex = std::max(idx - pn + 1 + LISTBOX_SCRMGN, 0);
		}
		lp->ItemIndex = idx;
	}
}
//---------------------------------------------------------------------------
//ListBox ̃J[\̈
//---------------------------------------------------------------------------
bool ListBoxCsrToVisible(TListBox *lp)
{
	int lst_idx = lp->ItemIndex;
	if (lp->ItemIndex < lp->TopIndex)
		lp->ItemIndex = lp->TopIndex;
	else {
		int idx_btm = lp->TopIndex + lp->ClientHeight/lp->ItemHeight - 1;
		if (lp->ItemIndex > idx_btm) lp->ItemIndex = idx_btm;
	}
	return (lst_idx != lp->ItemIndex);
}
//---------------------------------------------------------------------------
//ListBox ̃XN[
//---------------------------------------------------------------------------
void ListBoxScrollDown(TListBox *lp, int n,
	bool move_csr)	//J[\ړ (default = false)
{
	int idx = lp->TopIndex;
	lp->TopIndex = idx + n;
	n = lp->TopIndex - idx;
	if (move_csr) lp->ItemIndex += n;
}
//---------------------------------------------------------------------------
void ListBoxScrollDown(TListBox *lp, UnicodeString prm)
{
	if (!prm.IsEmpty()) {
		int pn = lp->ClientHeight/lp->ItemHeight;

		switch (idx_of_word_i("HP|FP|ED", prm)) {
		case 0:  ListBoxScrollDown(lp, pn/2);					break;
		case 1:  ListBoxScrollDown(lp, pn);						break;
		case 2:  lp->TopIndex = std::max(lp->Count - pn, 0);	break;
		default: ListBoxScrollDown(lp, prm.ToIntDef(1));
		}
	}
}

//---------------------------------------------------------------------------
void ListBoxScrollUp(TListBox *lp, int n,
	bool move_csr)	//J[\ړ (default = false)
{
	int idx = lp->TopIndex;
	if (n>lp->TopIndex) lp->TopIndex = 0; else lp->TopIndex = idx - n;
	n = lp->TopIndex - idx;
	if (move_csr) lp->ItemIndex += n;
}
//---------------------------------------------------------------------------
void ListBoxScrollUp(TListBox *lp, UnicodeString prm)
{
	if (!prm.IsEmpty()) {
		int pn = lp->ClientHeight/lp->ItemHeight;

		switch (idx_of_word_i("HP|FP|TP", prm)) {
		case 0:  ListBoxScrollUp(lp, pn/2);	break;
		case 1:  ListBoxScrollUp(lp, pn);	break;
		case 2:  lp->TopIndex = 0;			break;
		default: ListBoxScrollUp(lp, prm.ToIntDef(1));
		}
	}
}

//---------------------------------------------------------------------------
//ListBox łׂĂ̍ڂI
//---------------------------------------------------------------------------
void ListBoxSelectAll(TListBox *lp, bool sw)
{
	if (lp) lp->Perform(LB_SETSEL, (BOOL)sw, (NativeInt)-1);
}

//---------------------------------------------------------------------------
//ListBox œT[`
//---------------------------------------------------------------------------
int ListBoxInitialSearch(
	TListBox *lp,
	UnicodeString kptn,		//p^[
	bool fnam_sw)			//t@Cɑ΂ēKp (default = false)
{
	int idx0 = -1, idx1 = -1;
	try {
		TRegExOptions opt; opt << roIgnoreCase;
		for (int i=0; i<lp->Count && idx1==-1; i++) {
			if (i<=lp->ItemIndex && idx0!=-1) continue;
			UnicodeString lbuf = lp->Items->Strings[i];
			if (fnam_sw) lbuf = ExtractFileName(lbuf);
			if (TRegEx::IsMatch(lbuf, kptn, opt)) ((i<=lp->ItemIndex)? idx0 : idx1) = i;
		}
	}
	catch (...) {
		;
	}
	int idx = (idx1!=-1)? idx1 : idx0;
	if (idx!=-1) lp->ItemIndex = idx;
	return idx;
}

//---------------------------------------------------------------------------
//InfListBox ̌ݍsfBNg擾
//---------------------------------------------------------------------------
UnicodeString InfListBoxGetDir(TListBox *lp)
{
	int idx = lp->ItemIndex;
	return (idx!=-1 && ((int)lp->Items->Objects[idx] & LBFLG_PATH_FIF))?
						  get_tkn_r(lp->Items->Strings[idx], ": ") : EmptyStr;
}
//---------------------------------------------------------------------------
//ListBox ̌ݍsURL擾
//---------------------------------------------------------------------------
UnicodeString ListBoxGetURL(TListBox *lp)
{
	return (lp->ItemIndex!=-1)? extract_URL(lp->Items->Strings[lp->ItemIndex]) : EmptyStr;
}

//---------------------------------------------------------------------------
//ListBox  Objects 𐮐lƂă`FbNAژAԂݒ
//---------------------------------------------------------------------------
void set_ListBox_ItemNo(TListBox *lp)
{
	int itm_no	 = 0;
	int last_tag = -1;
	for (int i=0; i<lp->Count; i++) {
		int tag = (int)lp->Items->Objects[i];
		if (last_tag!=tag) {
			itm_no++;
			last_tag = tag;
		}
		lp->Items->Objects[i] = (TObject*)(NativeInt)itm_no;
	}

	lp->Invalidate();
}

//---------------------------------------------------------------------------
//TCheckListBox Ń`FbNĂ鍀ڐ擾
//---------------------------------------------------------------------------
int get_CheckListCount(TCheckListBox *lp)
{
	int cnt = 0;
	for (int i=0; i<lp->Count; i++) if (lp->Checked[i]) cnt++;
	return cnt;
}

//---------------------------------------------------------------------------
//TStringGrid ł̃J[\ړ
//---------------------------------------------------------------------------
void GridCursorLeft(TStringGrid *gp)
{
	if (gp->Col>0) gp->Col = gp->Col - 1;
}
//---------------------------------------------------------------------------
void GridCursorRight(TStringGrid *gp)
{
	if (gp->Col < gp->ColCount - 1) gp->Col = gp->Col + 1;
}
//---------------------------------------------------------------------------
void GridCursorDown(TStringGrid *gp)
{
	if (gp->Row < gp->RowCount - 1) gp->Row = gp->Row + 1;
}
//---------------------------------------------------------------------------
void GridCursorUp(TStringGrid *gp)
{
	if (gp->Row>gp->FixedRows) gp->Row = gp->Row - 1;
}
//---------------------------------------------------------------------------
void GridPageDown(TStringGrid *gp)
{
	int pn  = gp->VisibleRowCount - 1;
	int row = std::min(gp->Row + pn, gp->RowCount - 1);
	gp->Row = row;
}
//---------------------------------------------------------------------------
void GridPageUp(TStringGrid *gp)
{
	int pn  = gp->VisibleRowCount - 1;
	int row = std::max(gp->Row - pn, gp->FixedRows);
	gp->Row = row;
}
//---------------------------------------------------------------------------
bool GridCursorMove(UnicodeString cmd , TStringGrid *gp)
{
	switch (idx_of_word_i("CursorDown|CursorUp|PageDown|PageUp", cmd)) {
	case  0: GridCursorDown(gp);	break;
	case  1: GridCursorUp(gp);		break;
	case  2: GridPageDown(gp);		break;
	case  3: GridPageUp(gp);		break;
	default:						return false;
	}

	return true;
}

//---------------------------------------------------------------------------
//TStringList ̍ڂPֈړ
//---------------------------------------------------------------------------
int up_StrListItem(TStringList *lst, int idx)
{
	if (idx>=1 && idx<lst->Count) {
		lst->Move(idx, idx - 1);
		idx--;
	}
	return idx;
}
//---------------------------------------------------------------------------
//TStringList ̍ڂPֈړ
//---------------------------------------------------------------------------
int down_StrListItem(TStringList *lst, int idx)
{
	if (idx>=0 && idx<lst->Count - 1) {
		lst->Move(idx, idx + 1);
		idx++;
	}
	return idx;
}

//---------------------------------------------------------------------------
//ANZ[^L[̈v郊Xgڂ̃CfbNX擾
//---------------------------------------------------------------------------
int get_IndexFromAccKey(TStringList *lst, UnicodeString key)
{
	if (key.Length()!=1) return -1;
	key.Insert("&", 1);
	int idx = -1;
	for (int i=0; i<lst->Count; i++)
		if (ContainsText(get_csv_item(lst->Strings[i], 0), key)) { idx = i; break; }
	return idx;
}

//---------------------------------------------------------------------------
//񂩂URL([Jt@C܂)𒊏o
//---------------------------------------------------------------------------
UnicodeString extract_URL(UnicodeString s)
{
	if (s.Pos(':')==0) return EmptyStr;

	UnicodeString url;
	TMatch mt = TRegEx::Match(s, URL_MATCH_PTN);
	if (mt.Success) {
		url = mt.Value;
		if (!StartsStr('h', url)) url.Insert("h", 1);	//擪 h Ȃ₤
	}
	else {
		mt = TRegEx::Match(s, MAIL_MATCH_PTN);
		if (mt.Success) {
			url = mt.Value;
		}
		else {
			mt = TRegEx::Match(s, LOCAL_FILE_PTN);
			if (mt.Success) url = mt.Value;
		}
	}
	return url;
}

//---------------------------------------------------------------------------
//C^[lbgڑ邩?
//---------------------------------------------------------------------------
bool InternetConnected()
{
	DWORD flag;
	return InternetGetConnectedState(&flag, 0);
}

//---------------------------------------------------------------------------
//IC̃t@C擾
//---------------------------------------------------------------------------
int get_OnlineFile(UnicodeString url, UnicodeString fnam, bool *cancel,
	TPaintBox *prg_box,		//io[	(default = NULL)
	double *prg_ratio)		//i	(default = NULL)
{
	int f_size = -1;
	if (cancel) *cancel = false;

	if (!url.IsEmpty() && InternetConnected()) {
		HINTERNET hSession = InternetOpen(_T("NyanFi"), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
		if (hSession) {
			HINTERNET hConnect = InternetOpenUrl(hSession, url.c_str(), NULL, 0, INTERNET_FLAG_RELOAD, 0);
			if (hConnect) {
				DWORD dwFsize = 0;
				DWORD dwBufLen = sizeof(dwFsize);
				HttpQueryInfo(hConnect, HTTP_QUERY_CONTENT_LENGTH|HTTP_QUERY_FLAG_NUMBER,
						 (LPVOID)&dwFsize, &dwBufLen, 0);

				std::unique_ptr<BYTE[]> ldbuf(new BYTE[FILE_RBUF_SIZE]);
				DWORD dwSize;
				f_size = 0;

				std::unique_ptr<TMemoryStream> ms(new TMemoryStream());
				for (;;) {
					if (!InternetReadFile(hConnect, ldbuf.get(), FILE_RBUF_SIZE, &dwSize)) break;
					if (dwSize==0) break;
					ms->Write(ldbuf.get(), (System::LongInt)dwSize);
					f_size += dwSize;
					//io[
					if (prg_box && prg_ratio && dwFsize>0) {
						*prg_ratio = 1.0 * f_size / dwFsize;
						prg_box->Repaint();
					}
					if (cancel) {
						Application->ProcessMessages();
						if (*cancel) break;
					}
				}

				if (prg_box && prg_ratio) {
					*prg_ratio = 1.0;
					prg_box->Repaint(); Sleep(500);
				}

				if (!cancel || !*cancel) {
					//favicon Ȃ``FbN
					if (EndsText(":favicon", fnam) && f_size>64) {
						//.ico ?
						int tag = 0;
						unsigned short us_buf;
						ms->Seek(0, soFromBeginning);
						ms->ReadBuffer(&us_buf, 2);  if (us_buf==0) tag++;
						ms->ReadBuffer(&us_buf, 2);  if (us_buf==1) tag++;
						ms->ReadBuffer(&us_buf, 2);  if (us_buf>0)  tag++;
						if (tag<3) {
							//.png?
							tag = 0;
							BYTE b_buf;
							ms->Seek(0, soFromBeginning);
							ms->ReadBuffer(&b_buf, 1);  if (b_buf==0x89) tag++;
							ms->ReadBuffer(&b_buf, 1);  if (b_buf==0x50) tag++;
							ms->ReadBuffer(&b_buf, 1);  if (b_buf==0x4e) tag++;
							ms->ReadBuffer(&b_buf, 1);  if (b_buf==0x47) tag++;
							if (tag<4) f_size = -1;
						}
					}

					if (f_size>=0) {
						chk_cre_dir(ExtractFileDir(fnam));
						ms->SaveToFile(fnam);
					}
				}

				InternetCloseHandle(hConnect);
			}
		    InternetCloseHandle(hSession);
		}
	}
	return f_size;
}

//---------------------------------------------------------------------------
//Xvb^ݒ
//---------------------------------------------------------------------------
void set_SplitterWidht(TSplitter *sp, int sp_wd)
{
	int sz = ScaledInt(sp_wd, sp);
	if (sp->Align==alLeft || sp->Align==alRight) sp->Width = sz; else sp->Height = sz;
	sp->Repaint();
}

//---------------------------------------------------------------------------
//pl̔zu
//---------------------------------------------------------------------------
void set_PanelAlign(TPanel *pp, TSplitter *sp, int mode, int sp_wd)
{
	int sz = ScaledInt(sp_wd, sp);
	switch (mode) {
	case 1:	//E
		sp->Align = alLeft;
		pp->Align = alRight;
		sp->Align = alRight;
		sp->Width = pp->Visible? sz : 0;
		break;
	case 2:	//
		sp->Align = alRight;
		pp->Align = alLeft;
		sp->Align = alLeft;
		sp->Width = pp->Visible? sz : 0;
		break;
	case 3: //
		sp->Align  = alBottom;
		pp->Align  = alTop;
		sp->Align  = alTop;
		sp->Height = pp->Visible? sz : 0;
		break;
	default:	//0: 
		sp->Align  = alTop;
		pp->Align  = alBottom;
		sp->Align  = alBottom;
		sp->Height = pp->Visible? sz : 0;
	}
}
//---------------------------------------------------------------------------
void set_PanelAlign(TPanel *pp, TSplitter *sp, TAlign al, int sp_wd)
{
	switch (al) {
	case alTop:		set_PanelAlign(pp, sp, 3, sp_wd);	break;
	case alBottom:	set_PanelAlign(pp, sp, 0, sp_wd);	break;
	case alLeft:	set_PanelAlign(pp, sp, 2, sp_wd);	break;
	case alRight:	set_PanelAlign(pp, sp, 1, sp_wd);	break;
	default:
		;
	}
}

//---------------------------------------------------------------------------
//Rg[Eɔzu
//---------------------------------------------------------------------------
void set_ControlRBCorner(TControl *cp0, TControl *cp1)
{
	if (cp0->Visible && cp1->Visible) {
		cp1->Left = cp0->Left + cp0->ClientWidth  - cp1->Width;
		cp1->Top  = cp0->Top  + cp0->ClientHeight - cp1->Height;
		cp1->BringToFront();
	}
}

//---------------------------------------------------------------------------
//obec(%)̕擾
//---------------------------------------------------------------------------
UnicodeString get_BatteryPercentStr()
{
	SYSTEM_POWER_STATUS ps;
	::GetSystemPowerStatus(&ps);
	if (ps.BatteryLifePercent==255) return "---";
	return UnicodeString().sprintf(_T("%3u"), ps.BatteryLifePercent);
}
//---------------------------------------------------------------------------
//obec()̕擾
//---------------------------------------------------------------------------
UnicodeString get_BatteryTimeStr()
{
	SYSTEM_POWER_STATUS ps;
	::GetSystemPowerStatus(&ps);

	UnicodeString ret;
	if (ps.ACLineStatus==1) {
		ret = "ONLINE";
	}
	else {
		int s = ps.BatteryLifeTime;
		if (s==-1)
			ret = "--:--";
		else
			ret.sprintf(_T("%u:%02u"), s/3600, (s%3600)/60);
	}
	return ret;
}

//---------------------------------------------------------------------------
//hCu̎O
//  ߂l: O/O\ ̏ꍇ true
//---------------------------------------------------------------------------
bool EjectDrive(
	UnicodeString drvnam,	//hCu
	bool eject)				//true=O/ false=mF̂
{
	if (EjectDrive2(drvnam, eject)) return true;

	drvnam = ExtractFileDrive(drvnam);
	if (drvnam.IsEmpty()) return false;
	drvnam = IncludeTrailingPathDelimiter(drvnam);

	int typ = ::GetDriveType(drvnam.c_str());
	DWORD dwAccessFlags;
	switch(typ) {
	case DRIVE_REMOVABLE:	dwAccessFlags = GENERIC_READ|GENERIC_WRITE;	break;
	case DRIVE_CDROM:		dwAccessFlags = GENERIC_READ;				break;
	default:				return false;
	}

	bool ret = false;
	UnicodeString drv = "\\\\.\\" + ExtractFileDrive(drvnam);
	HANDLE hDrive = ::CreateFile(drv.c_str(), dwAccessFlags,
		FILE_SHARE_READ|FILE_SHARE_WRITE, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if (hDrive!=INVALID_HANDLE_VALUE) {
		if (eject) {
			if (typ==DRIVE_CDROM) {
				//ID=37: uov𒼐ڎs
				ret = usr_SH->DriveContextMenu(Application->ActiveFormHandle, drvnam, NULL, 37).IsEmpty();
			}
			else {
				//{[bN
				bool locked = false;
				DWORD dwBytesReturned;
				for (int i = 0; i<20; i++) {
					if (::DeviceIoControl(hDrive, FSCTL_LOCK_VOLUME, NULL, 0, NULL, 0, &dwBytesReturned, NULL)) {
						locked = true; break;
					}
					Sleep(10000/20);	//10b/20񃊃gC
				}
				if (locked) {
					//}Eg
					if (::DeviceIoControl(hDrive, FSCTL_DISMOUNT_VOLUME, NULL, 0, NULL, 0, &dwBytesReturned, NULL)) {
						//폜W邩foCX~
						PREVENT_MEDIA_REMOVAL PMRBuffer;
						PMRBuffer.PreventMediaRemoval = FALSE;
						if (::DeviceIoControl(hDrive, IOCTL_STORAGE_MEDIA_REMOVAL,
							&PMRBuffer, sizeof(PREVENT_MEDIA_REMOVAL), NULL, 0, &dwBytesReturned, NULL))
						{
							//O
							::DeviceIoControl(hDrive, IOCTL_STORAGE_EJECT_MEDIA, NULL, 0, NULL, 0, &dwBytesReturned, NULL);
						}
						ret = true;
					}
				}
			}
		}
		else ret = true;

		::CloseHandle(hDrive);
	}

	return ret;
}
//---------------------------------------------------------------------------
//[ou/CD-ROM ȊO̎O
//---------------------------------------------------------------------------
bool EjectDrive2(UnicodeString drvnam, bool eject)
{
	drvnam = ExtractFileDrive(drvnam);
	if (drvnam.IsEmpty()) return false;
	drvnam = IncludeTrailingPathDelimiter(drvnam);

	//hCũ{[擾
	_TCHAR pszVolName[MAX_PATH];
	if (!::GetVolumeNameForVolumeMountPoint(drvnam.c_str(), pszVolName, MAX_PATH)) return false;
	UnicodeString vol_name = pszVolName;

	//{[̈vfoCX
	bool res = false;
	HDEVINFO hDevInfo = ::SetupDiGetClassDevs(NULL, 0, 0, DIGCF_PRESENT|DIGCF_ALLCLASSES);
	if (hDevInfo!=INVALID_HANDLE_VALUE) {
		bool found = false;
		SP_DEVINFO_DATA DevInfoData = {sizeof(SP_DEVINFO_DATA)};

		for (DWORD i=0; !found && SetupDiEnumDeviceInfo(hDevInfo, i, &DevInfoData); i++) {
			ULONG status  = 0;
			ULONG problem = 0;
			if (::CM_Get_DevNode_Status(&status, &problem, DevInfoData.DevInst, 0)!=CR_SUCCESS) continue;
			if ((status & DN_DISABLEABLE)==0 || (status & DN_REMOVABLE)==0) continue;

			DEVINST devInstChild;
			if (CM_Get_Child(&devInstChild, DevInfoData.DevInst, 0)==CR_SUCCESS) {
				_TCHAR pszDevInstanceId[MAX_PATH];
				if (CM_Get_Device_ID(devInstChild, pszDevInstanceId, MAX_PATH, 0)==CR_SUCCESS) {
					UnicodeString strDiList;
					ULONG ulSize;
					if (CM_Get_Device_Interface_List_Size(&ulSize, (LPGUID)&VolumeClassGuid,
							pszDevInstanceId, 0)==CR_SUCCESS)
					{
						std::unique_ptr<_TCHAR[]> pszList(new _TCHAR[ulSize + 1]);
						if (CM_Get_Device_Interface_List((LPGUID)&VolumeClassGuid,
							pszDevInstanceId, pszList.get(), ulSize, 0)==CR_SUCCESS)
								strDiList = UnicodeString(pszList.get());
					}
					if (strDiList.IsEmpty()) {
						if (CM_Get_Device_ID_List_Size(&ulSize, pszDevInstanceId,
								CM_GETIDLIST_FILTER_REMOVALRELATIONS )==CR_SUCCESS)
						{
							std::unique_ptr<_TCHAR[]> pDeviceIDsList(new _TCHAR[ulSize]);
							if (CM_Get_Device_ID_List(pszDevInstanceId, pDeviceIDsList.get(),
									ulSize, CM_GETIDLIST_FILTER_REMOVALRELATIONS)==CR_SUCCESS)
							{
								if (CM_Get_Device_Interface_List_Size(&ulSize, (LPGUID)&VolumeClassGuid,
										pDeviceIDsList.get(), 0)==CR_SUCCESS)
								{
									std::unique_ptr<_TCHAR[]> pDeviceInterfacesList(new _TCHAR[ulSize]);
									if (CM_Get_Device_Interface_List((LPGUID)&VolumeClassGuid, pDeviceIDsList.get(),
										 pDeviceInterfacesList.get(), ulSize, 0) == CR_SUCCESS)
											strDiList = pDeviceInterfacesList.get();
								}
							}
						}
					}
					if (!strDiList.IsEmpty()) {
						strDiList = IncludeTrailingPathDelimiter(strDiList);
						if (!GetVolumeNameForVolumeMountPoint(strDiList.c_str(), pszVolName, MAX_PATH)) continue;
						if (SameText(vol_name, pszVolName)) {
							found = true;
							//O
							res = eject? (CM_Request_Device_Eject(DevInfoData.DevInst, NULL, NULL, 0, 0)==CR_SUCCESS) : true;
						}
					}
				}
			}
		}
		::SetupDiDestroyDeviceInfoList(hDevInfo);
	}
	return res;
}

//---------------------------------------------------------------------------
//Rg[̃NX`FbN
//---------------------------------------------------------------------------
bool class_is_LabeledEdit(TObject *op)
{
	return (op && op->ClassNameIs("TLabeledEdit"));
}
//---------------------------------------------------------------------------
bool class_is_MaskEdit(TObject *op)
{
	return (op && op->ClassNameIs("TMaskEdit"));
}
//---------------------------------------------------------------------------
bool class_is_CustomEdit(TObject *op)
{
	return (op && op->InheritsFrom(__classid(TCustomEdit)));
}
//---------------------------------------------------------------------------
bool class_is_Edit(TObject *op)
{
	return (op && op->ClassNameIs("TEdit"));
}
//---------------------------------------------------------------------------
bool class_is_CheckBox(TObject *op)
{
	return (op && op->ClassNameIs("TCheckBox"));
}
//---------------------------------------------------------------------------
bool class_is_ComboBox(TObject *op)
{
	return (op && op->ClassNameIs("TComboBox"));
}
//---------------------------------------------------------------------------
bool class_is_ListBox(TObject *op)
{
	return (op && op->ClassNameIs("TListBox"));
}
//---------------------------------------------------------------------------
bool class_is_CheckListBox(TObject *op)
{
	return (op && op->ClassNameIs("TCheckListBox"));
}
//---------------------------------------------------------------------------
bool class_is_RadioGroup(TObject *op)
{
	return (op && op->ClassNameIs("TRadioGroup"));
}

//---------------------------------------------------------------------------
void cursor_HourGlass()
{
	Screen->Cursor = crHourGlass;
}
//---------------------------------------------------------------------------
void cursor_Default()
{
	Screen->Cursor = crDefault;
}

//---------------------------------------------------------------------------
//j[̗]vȃZp[^\ɂ
//ŏ̕\ AutoLineReduction ȂɑΏ
//---------------------------------------------------------------------------
void reduction_MenuLine(TMenuItem *mp)
{
	if (!mp) return;

	bool is_sp = false;
	TMenuItem *ip_0 = NULL;		//ŏ̕\
	TMenuItem *ip_1 = NULL;		//Ō̕\

	for (int i=0; i<mp->Count; i++) {
		TMenuItem *ip = mp->Items[i];
		if (ip->Action) ip->Action->Update();
		if (SameStr(ip->Caption, "-")) {
			ip->Visible = !is_sp;
			is_sp = true;
		}
		else if (ip->Visible) {
			is_sp = false;
		}

		if (ip->Visible) {
			if (!ip_0) ip_0 = ip;
			ip_1 = ip;
		}
	}

	if (ip_0 && SameStr(ip_0->Caption, "-")) ip_0->Visible = false;
	if (ip_1 && SameStr(ip_1->Caption, "-")) ip_1->Visible = false;
}

//---------------------------------------------------------------------------
//Web
//---------------------------------------------------------------------------
UnicodeString WebSeaUrl;		//WebSearch:  GWURL

//---------------------------------------------------------------------------
//Web\擾
//---------------------------------------------------------------------------
UnicodeString get_WebSeaCaption(
	UnicodeString kwd,	//				(default = EmptyStr)
	bool with_ak)		//ANZ[^t	(default = true)
{
	UnicodeString ret_str;
	if (!kwd.IsEmpty()) {
		kwd = Trim(get_first_line(kwd));
		kwd = ReplaceStr(kwd, "&", "&&");
		if (kwd.Length()>20) kwd = kwd.SubString(1, 20) + "c";
		if (!kwd.IsEmpty()) ret_str.sprintf(_T("u%sv "), kwd.c_str());
	}

	UnicodeString url = get_tkn_m(WebSeaUrl, "//", "/");
	remove_top_text(url, "www.");
	if (url.IsEmpty()) url = "Web";
	ret_str.cat_sprintf(_T("%s Ō"), url.c_str());
	if (with_ak) ret_str += "(&S)";

	return ret_str;
}

//---------------------------------------------------------------------------
//Webs
//---------------------------------------------------------------------------
bool exe_WebSearch(UnicodeString kwd)
{
	UnicodeString url;
	if (!kwd.IsEmpty()) {
		kwd = System::Netencoding::TURLEncoding::URL->Encode(kwd);
		url = ReplaceStr(WebSeaUrl, "\\S", kwd);
	}

	return (!url.IsEmpty()?
			(::ShellExecute(NULL, _T("open"), url.c_str(), NULL, NULL, SW_SHOWNORMAL) > (HINSTANCE)32) : false);
}
//---------------------------------------------------------------------------
